From 33ccca65daacb44cfb526bdabcd3a3d9c06443f1 Mon Sep 17 00:00:00 2001
From: Amul Sul <amul.sul@enterprisedb.com>
Date: Tue, 20 Aug 2024 09:44:56 +0530
Subject: [PATCH] Remove unnecessary #include statements.

---
 src/bin/pg_verifybackup/pg_verifybackup.c | 3 ---
 1 file changed, 3 deletions(-)

diff --git a/src/bin/pg_verifybackup/pg_verifybackup.c b/src/bin/pg_verifybackup/pg_verifybackup.c
index 3fcfb167217..2a461079a38 100644
--- a/src/bin/pg_verifybackup/pg_verifybackup.c
+++ b/src/bin/pg_verifybackup/pg_verifybackup.c
@@ -18,9 +18,6 @@
 #include <sys/stat.h>
 #include <time.h>
 
-#include "common/logging.h"
-#include "common/parse_manifest.h"
-#include "fe_utils/simple_list.h"
 #include "getopt_long.h"
 #include "pg_verifybackup.h"
 #include "pgtime.h"
-- 
2.18.0